KDE 4.7 PyKDE API Reference

- KDE's Python API

# KCompletion Class Reference

`from PyKDE4.kdeui import *`

Inherits: QObject

## Detailed Description

A generic class for completing QStrings

This class offers easy use of "auto-completion", "manual-completion" or "shell completion" on QString objects. A common use is completing filenames or URLs (see KUrlCompletion()). But it is not limited to URL-completion -- everything should be completable! The user should be able to complete email-addresses, telephone-numbers, commands, SQL queries, ... Every time your program knows what the user can type into an edit-field, you should offer completion. With KCompletion, this is very easy, and if you are using a line edit widget ( KLineEdit), it is even more easy. Basically, you tell a KCompletion object what strings should be completable and whenever completion should be invoked, you call makeCompletion(). KLineEdit and (an editable) KComboBox even do this automatically for you.

KCompletion offers the completed string via the signal match() and all matching strings (when the result is ambiguous) via the method allMatches().

Notice: auto-completion, shell completion and manual completion work slightly differently:

- auto-completion always returns a complete item as match.
When more than one matching items are available, it will deliver just the first (depending on sorting order) item. Iterating over all matches is possible via nextMatch() and previousMatch().

- popup-completion works in the same way, the only difference being that
the completed items are not put into the edit-widget, but into a separate popup-box.

- manual completion works the same way as auto-completion, the
subtle difference is, that it isn't invoked automatically while the user is typing, but only when the user presses a special key. The difference of manual and auto-completion is therefore only visible in UI classes, KCompletion needs to know whether to deliver partial matches (shell completion) or whole matches (auto/manual completion), therefore KGlobalSettings.CompletionMan and KGlobalSettings.CompletionAuto have the exact same effect in KCompletion.

- shell completion works like how shells complete filenames:
when multiple matches are available, the longest possible string of all matches is returned (i.e. only a partial item). Iterating over all matching items (complete, not partial) is possible via nextMatch() and previousMatch().

You don't have to worry much about that though, KCompletion handles that for you, according to the setting setCompletionMode(). The default setting is globally configured by the user and read from KGlobalSettings.completionMode().

A short example:

     KCompletion completion;
     completion.setOrder( KCompletion.Sorted );
     completion.addItem( "pfeiffer@kde.org" );
     completion.addItem( "coolo@kde.org" );
     completion.addItem( "carpdjih@sp.zrz.tu-berlin.de" );
     completion.addItem( "carp@cs.tu-berlin.de" );

     cout << completion.makeCompletion( "ca" ).latin1() << endl;

In shell-completion-mode, this will be "carp"; in auto-completion- mode it will be "carp\@cs.tu-berlin.de", as that is alphabetically smaller. If setOrder was set to Insertion, "carpdjih\@sp.zrz.tu-berlin.de" would be completed in auto-completion-mode, as that was inserted before "carp\@cs.tu-berlin.de".

You can dynamically update the completable items by removing and adding them whenever you want. For advanced usage, you could even use multiple KCompletion objects. E.g. imagine an editor like kwrite with multiple open files. You could store items of each file in a different KCompletion object, so that you know (and tell the user) where a completion comes from.

Note: KCompletion does not work with strings that contain 0x0 characters (unicode nul), as this is used internally as a delimiter.

You may inherit from KCompletion and override makeCompletion() in special cases (like reading directories/urls and then supplying the contents to KCompletion, as KUrlCompletion does), but generally, this is not necessary.

Author:
  Carsten Pfeiffer <pfeiffer@kde.org>

## Enumerations
CompOrder | { Sorted, Insertion, Weighted }
## Signals
| match (QString item)
| matches (QStringList matchlist)
| multipleMatches ()
## Methods
| __init__ (self)
| __init__ (self, KCompletion a0)
| addItem (self, QString item)
| addItem (self, QString item, long weight)
QStringList | allMatches (self)
QStringList | allMatches (self, QString string)
| clear (self)
KGlobalSettings.Completion | completionMode (self)
bool | hasMultipleMatches (self)
bool | ignoreCase (self)
| insertItems (self, QStringList items)
bool | isEmpty (self)
QStringList | items (self)
QString | lastMatch (self)
QString | makeCompletion (self, QString string)
QString | nextMatch (self)
KCompletion.CompOrder | order (self)
| postProcessMatch (self, QString pMatch)
| postProcessMatches (self, QStringList pMatches)
QString | previousMatch (self)
| removeItem (self, QString item)
| setCompletionMode (self, KGlobalSettings.Completion mode)
| setIgnoreCase (self, bool ignoreCase)
| setItems (self, QStringList list)
| setOrder (self, KCompletion.CompOrder order)
| setSoundsEnabled (self, bool enable)
| slotMakeCompletion (self, QString string)
| slotNextMatch (self)
| slotPreviousMatch (self)
bool | soundsEnabled (self)
QStringList | substringCompletion (self, QString string)

## Signal Documentation

match | ( | QString | item
| ) |  |  |

The matching item. Will be emitted by makeCompletion(), previousMatch() or nextMatch(). May be QString() if there is no matching item.

Parameters:

  | item | the match, or QString() if there is none

Signal syntax:
  `QObject.connect(source, SIGNAL("match(const QString&)"), target_slot)`

matches | ( | QStringList | matchlist
| ) |  |  |

All matching items. Will be emitted by makeCompletion() in shell- completion-mode, when the same string is passed to makeCompletion twice or more often.

Parameters:

  | matchlist | the list of matches

Signal syntax:
  `QObject.connect(source, SIGNAL("matches(const QStringList&)"), target_slot)`

multipleMatches | ( |  | ) |

This signal is emitted, when calling makeCompletion() and more than one matching item is found.

See also:
  hasMultipleMatches

Signal syntax:
  `QObject.connect(source, SIGNAL("multipleMatches()"), target_slot)`

## Method Documentation

__init__ | ( |  | self ) |

Constructor, nothing special here :)

__init__ | ( | self, |
|  | KCompletion | a0
| ) |  |  |

Constructor, nothing special here :)

addItem | ( | self, |
|  | QString | item
| ) |  |  |

Adds an item to the list of available completions. Resets the current item-state ( previousMatch() and nextMatch() won't work anymore).

Sets the weighting of the item to weight or adds it to the current weighting if the item is already available. The weight has to be greater than 1 to take effect (default weight is 1).

Parameters:

  | item | the item to add
  | weight | the weight of the item, default is 1

addItem | ( | self, |
|  | QString | item,
|  | long | weight
| ) |  |  |

Adds an item to the list of available completions. Resets the current item-state ( previousMatch() and nextMatch() won't work anymore).

Sets the weighting of the item to weight or adds it to the current weighting if the item is already available. The weight has to be greater than 1 to take effect (default weight is 1).

Parameters:

  | item | the item to add
  | weight | the weight of the item, default is 1

QStringList allMatches | ( |  | self ) |

Returns a list of all items matching string.

Parameters:

  | string | the string to match

Returns:
  the list of all matches

QStringList allMatches | ( | self, |
|  | QString | string
| ) |  |  |

Returns a list of all items matching string.

Parameters:

  | string | the string to match

Returns:
  the list of all matches

clear | ( |  | self ) |

Removes all inserted items.

KGlobalSettings.Completion completionMode | ( |  | self ) |

Return the current completion mode. May be different from KGlobalSettings.completionMode(), if you explicitly called setCompletionMode().

Returns:
  the current completion mode

See also:
  setCompletionMode

bool hasMultipleMatches | ( |  | self ) |

Returns true when more than one match is found.

Returns:
  true if there are more than one match

See also:
  multipleMatches

bool ignoreCase | ( |  | self ) |

Return whether KCompletion acts case insensitively or not. Default is false (case sensitive).

Returns:
  true if the case will be ignored

See also:
  setIgnoreCase

insertItems | ( | self, |
|  | QStringList | items
| ) |  |  |

Inserts items into the list of possible completions. Does the same as setItems(), but does not call clear() before.

Parameters:

  | items | the items to insert

bool isEmpty | ( |  | self ) |

Returns true when the completion object contains no entries.

QStringList items | ( |  | self ) |

Returns a list of all items inserted into KCompletion. This is useful if you need to save the state of a KCompletion object and restore it later.

Important note: when order() == Weighted, then every item in the stringlist has its weight appended, delimited by a colon. E.g. an item "www.kde.org" might look like "www.kde.org:4", where 4 is the weight.

This is necessary so that you can save the items along with its weighting on disk and load them back with setItems(), restoring its weight as well. If you really don't want the appended weightings, call setOrder( KCompletion.Insertion ) before calling items().

Returns:
  a list of all items

See also:
  setItems

QString lastMatch | ( |  | self ) |

Returns the last match. Might be useful if you need to check whether a completion is different from the last one.

Returns:
  the last match. QString() is returned when there is no last match.

QString makeCompletion | ( | self, |
|  | QString | string
| ) |  |  |

Attempts to find an item in the list of available completions, that begins with string. Will either return the first matching item (if there is more than one match) or QString(), if no match was found.

In the latter case, a sound will be issued, depending on soundsEnabled(). If a match was found, it will also be emitted via the signal match().

If this is called twice or more often with the same string while no items were added or removed in the meantime, all available completions will be emitted via the signal #matches(). This happens only in shell-completion-mode.

Parameters:

  | string | the string to complete

Returns:
  the matching item, or QString() if there is no matching item.

See also:
  slotMakeCompletion

See also:
  substringCompletion

QString nextMatch | ( |  | self ) |

Returns the next item from the matching-items-list. When reaching the last item, the list is rotated, so it will return the first match and a sound is issued (depending on soundsEnabled()).

Returns:
  the next item from the matching-items-list. When there is no match, QString() is returned and a sound is issued

See also:
  slotNextMatch

KCompletion.CompOrder order | ( |  | self ) |

Returns the completion order.

Returns:
  the current completion order.

See also:
  setOrder

postProcessMatch | ( | self, |
|  | QString | pMatch
| ) |  |  |

This method is called after a completion is found and before the matching string is emitted. You can override this method to modify the string that will be emitted. This is necessary e.g. in KUrlCompletion(), where files with spaces in their names are shown escaped ("filename\ with\ spaces"), but stored unescaped inside KCompletion. Never delete that pointer!

Default implementation does nothing.

Parameters:

  | pMatch | the match to process

See also:
  postProcessMatches

postProcessMatches | ( | self, |
|  | QStringList | pMatches
| ) |  |  |

This method is called before a list of all available completions is emitted via #matches. You can override this method to modify the found items before #match() or #matches() are emitted. Never delete that pointer!

Default implementation does nothing.

Parameters:

  | pMatches | the matches to process

See also:
  postProcessMatch

QString previousMatch | ( |  | self ) |

Returns the next item from the matching-items-list. When reaching the beginning, the list is rotated so it will return the last match and a sound is issued (depending on soundsEnabled()).

Returns:
  the next item from the matching-items-list. When there is no match, QString() is returned and a sound is be issued.

See also:
  slotPreviousMatch

removeItem | ( | self, |
|  | QString | item
| ) |  |  |

Removes an item from the list of available completions. Resets the current item-state ( previousMatch() and nextMatch() won't work anymore).

Parameters:

  | item | the item to remove

setCompletionMode | ( | self, |
|  | KGlobalSettings.Completion | mode
| ) |  |  |

Sets the completion mode to Auto/Manual, Shell or None. If you don't set the mode explicitly, the global default value KGlobalSettings.completionMode() is used. KGlobalSettings.CompletionNone disables completion.

Parameters:

  | mode | the completion mode

See also:
  completionMode

See also:
  KGlobalSettings.completionMode

setIgnoreCase | ( | self, |
|  | bool | ignoreCase
| ) |  |  |

Setting this to true makes KCompletion behave case insensitively. E.g. makeCompletion( "CA" ); might return "carp\@cs.tu-berlin.de". Default is false (case sensitive).

Parameters:

  | ignoreCase | true to ignore the case

See also:
  ignoreCase

setItems | ( | self, |
|  | QStringList | list
| ) |  |  |

Sets the list of items available for completion. Removes all previous items.

Notice: when order() == Weighted, then the weighting is looked up for every item in the stringlist. Every item should have ":number" appended, where number is an unsigned integer, specifying the weighting.

If you don't like this, call setOrder( KCompletion.Insertion ) before calling setItems().

Parameters:

  | list | the list of items that are available for completion

See also:
  items

setOrder | ( | self, |
|  | KCompletion.CompOrder | order
| ) |  |  |

KCompletion offers three different ways in which it offers its items:

- in the order of insertion
- sorted alphabetically
- weighted

Choosing weighted makes KCompletion perform an implicit weighting based on how often an item is inserted. Imagine a web browser with a location bar, where the user enters URLs. The more often a URL is entered, the higher priority it gets.

Note: Setting the order to sorted only affects new inserted items, already existing items will stay in the current order. So you probably want to call setOrder( Sorted ) before inserting items, when you want everything sorted.

Default is insertion order.

Parameters:

  | order | the new order

See also:
  order

setSoundsEnabled | ( | self, |
|  | bool | enable
| ) |  |  |

Enables/disables playing a sound when

- makeCompletion() can't find a match
- there is a partial completion (= multiple matches in
Shell-completion mode)
- nextMatch() or previousMatch() hit the last possible
match -> rotation

For playing the sounds, KNotifyClient() is used.

Parameters:

  | enable | true to enable sounds

See also:
  soundsEnabled

slotMakeCompletion | ( | self, |
|  | QString | string
| ) |  |  |

Attempts to complete "string" and emits the completion via match(). Same as makeCompletion() (just as a slot).

Parameters:

  | string | the string to complete

See also:
  makeCompletion

slotNextMatch | ( |  | self ) |

Searches the next matching item and emits it via match(). Same as nextMatch() (just as a slot).

See also:
  nextMatch

slotPreviousMatch | ( |  | self ) |

Searches the previous matching item and emits it via match(). Same as previousMatch() (just as a slot).

See also:
  previousMatch

bool soundsEnabled | ( |  | self ) |

Tells you whether KCompletion will play sounds on certain occasions. Default is enabled.

Returns:
  true if sounds are enabled

See also:
  setSoundsEnabled

QStringList substringCompletion | ( | self, |
|  | QString | string
| ) |  |  |

Returns a list of all completion items that contain the given string.

Parameters:

  | string | the string to complete

Returns:
  a list of items which all contain text as a substring, i.e. not necessarily at the beginning.

See also:
  makeCompletion

## Enumeration Documentation

CompOrder

Constants that represent the order in which KCompletion performs completion-lookups.

Enumerator:

  Sorted |
  Insertion |
  Weighted |